<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryRef"
      :inline="true"
      v-show="showSearch"
      label-width="68px"
    >
      <el-form-item label="姓名" prop="name">
        <el-input
          v-model="queryParams.name"
          placeholder="请输入姓名"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <!-- <el-form-item label="电话" prop="phone">
        <el-input
          v-model="queryParams.phone"
          placeholder="请输入电话"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item> -->
      <el-form-item label="类别" prop="phone">
        <el-select v-model="queryParams.type" placeholder="请选择类别">
          <el-option
            v-for="dict in sms_type"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
            >{{ dict.label }}</el-option
          ></el-select
        >
      </el-form-item>
      <el-form-item label="日期" style="width: 308px">
        <el-date-picker
          v-model="dateRange"
          value-format="YYYY-MM-DD"
          type="daterange"
          range-separator="-"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
        ></el-date-picker>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery"
          >搜索</el-button
        >
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="Delete"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['system:sms:remove']"
          >删除</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="Download"
          @click="handleExport"
          v-hasPermi="['system:sms:export']"
          >导出</el-button
        >
      </el-col>
      <right-toolbar
        v-model:showSearch="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="smsList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column width="55" label="序号" align="center" type="index" />
      <el-table-column width="100" label="姓名" align="center" prop="name" />
      <el-table-column
        width="120"
        label="手机号码"
        align="center"
        prop="phone"
      />

      <el-table-column
        min-width="380"
        label="发送内容"
        align="center"
        prop="content"
      />
      <el-table-column label="发送状态" align="center" prop="result">
      </el-table-column>
      <el-table-column
        width="160"
        label="发送时间"
        align="center"
        prop="createTime"
      >
      </el-table-column>
      <el-table-column label="短信类别" align="center" prop="type">
        <template #default="scope">
          <dict-tag :options="sms_type" :value="scope.row.type" />
        </template>
      </el-table-column>
      <!-- <el-table-column label="结果" align="center" prop="result" /> -->
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
      >
        <template #default="scope">
          <el-button
            link
            type="primary"
            icon="Delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['system:sms:remove']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改sms对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="smsRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="电话" prop="phone">
          <el-input v-model="form.phone" placeholder="请输入电话" />
        </el-form-item>
        <el-form-item label="人员" prop="name">
          <el-input v-model="form.name" placeholder="请输入人员" />
        </el-form-item>
        <el-form-item label="短信内容" prop="content">
          <el-input
            v-model="form.content"
            type="textarea"
            placeholder="请输入内容"
          />
        </el-form-item>
        <el-form-item label="结果" prop="result">
          <el-input v-model="form.result" placeholder="请输入结果" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Sms">
import { listSms, getSms, delSms, addSms, updateSms } from "@/api/system/sms";

const { proxy } = getCurrentInstance();
const { sms_type } = proxy.useDict("sms_type");
const smsList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");
const dateRange = ref("");
const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    phone: null,
    name: null,
    content: null,
    result: null,
    type: null,
    orderByColumn: "createTime",
    isAsc: "Desc",
  },
  rules: {},
});

const { queryParams, form, rules } = toRefs(data);

/** 查询sms列表 */
function getList() {
  loading.value = true;
  listSms(proxy.addDateRange(queryParams.value, dateRange.value)).then(
    (response) => {
      smsList.value = response.rows;
      total.value = response.total;
      loading.value = false;
      smsList.value.forEach((item) => {
        item.result = JSON.parse(item.result).message;
      });
    }
  );
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    id: null,
    phone: null,
    name: null,
    content: null,
    createTime: null,
    createBy: null,
    result: null,
  };
  proxy.resetForm("smsRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  console.log("745", dateRange.value);
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  dateRange.value = "";
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map((item) => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加sms";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _id = row.id || ids.value;
  getSms(_id).then((response) => {
    form.value = response.data;
    open.value = true;
    title.value = "修改sms";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["smsRef"].validate((valid) => {
    if (valid) {
      if (form.value.id != null) {
        updateSms(form.value).then((response) => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addSms(form.value).then((response) => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value;
  proxy.$modal
    .confirm('是否确认删除sms编号为"' + _ids + '"的数据项？')
    .then(function () {
      return delSms(_ids);
    })
    .then(() => {
      getList();
      proxy.$modal.msgSuccess("删除成功");
    })
    .catch(() => {});
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download(
    "system/sms/export",
    {
      ...queryParams.value,
    },
    `sms_${new Date().getTime()}.xlsx`
  );
}

getList();
</script>
